//rlyeh
 
#include "shared.h"
#undef u8
#undef u16
#undef u32
#undef s8
#undef s16
#undef s32
#include <gp32.h>

#undef RGB2INT

#define FIXED-D_MSG 1

#include "port/gp32/gp32_rl.h"

#ifdef SND_ROB
#define GpTickCountGet() Timer
#undef  ONE_SECOND
#define ONE_SECOND 60
#endif


#undef  ONE_SECOND
#define ONE_SECOND (2*2000)




int chatboard=0, chatboardSymb=0, chatboardShift=0, chatboardExt=0;
void GetPad(void);


//OPQAM/SP,OP1QM/SP,KLAZM/SP,ZXPL0/SP,QABNM/SP,QZIPM/SP,1ZIPM/SP,670OM/SP
byte mapped_joystick = 0;
byte mapped_joysticks[][6] = {
{ SPECKEY_O,SPECKEY_P,SPECKEY_Q,SPECKEY_A,SPECKEY_M,SPECKEY_SPACE },
{ SPECKEY_O,SPECKEY_P,SPECKEY_1,SPECKEY_Q,SPECKEY_M,SPECKEY_SPACE },
{ SPECKEY_K,SPECKEY_L,SPECKEY_A,SPECKEY_Z,SPECKEY_M,SPECKEY_SPACE },
{ SPECKEY_Z,SPECKEY_X,SPECKEY_P,SPECKEY_L,SPECKEY_0,SPECKEY_SPACE },
{ SPECKEY_B,SPECKEY_N,SPECKEY_Q,SPECKEY_A,SPECKEY_M,SPECKEY_SPACE },
{ SPECKEY_I,SPECKEY_P,SPECKEY_Q,SPECKEY_Z,SPECKEY_M,SPECKEY_SPACE },
{ SPECKEY_I,SPECKEY_P,SPECKEY_1,SPECKEY_Z,SPECKEY_M,SPECKEY_SPACE },
{ SPECKEY_6,SPECKEY_7,SPECKEY_0,SPECKEY_O,SPECKEY_M,SPECKEY_SPACE },
{ (byte)-1, (byte)-1, (byte)-1, (byte)-1, (byte)-1, (byte)-1 }
} ;



char MyStateName[255];



void msg(char *s)
{
 DrawMessageC(s);
 FlipScreen(1,0);
 DrawMessageC(s);
 FlipScreen(1,0);
 DrawMessageC(s);
 FlipScreen(1,0);
 while(!GpKeyGet()); while(GpKeyGet());
}


unsigned char *LCDs8;

#ifdef HPL

void set_zx_palette(int gray)
 {
  int i;

  for(i=0;i<252;i++)
   {
    unsigned char r,g,b;
    r=g=b=0;
    if(i<17)
    {
     r=colores[i][0]*4;
     g=colores[i][1]*4;
     b=colores[i][2]*4;

     if(gray)
     {
      int x=(r+g+b)/3;
      r=g=b=x;
     }
    }
    SetColor(i,r,g,b);
   }
 }


void GpMain(void *arg)
{
 GpGraphicModeSet(GPC_DFLAG_8BPP, NULL);
 GpLcdEnable();

 GpFatInit();

 set_zx_palette(mPalette);

 ZX_Init();
 while(1)
 {
  int key=GpKeyGet();

  ZX_Frame(0);

  if(key&GPC_VK_FB) ZXKey(SPECKEY_Z);

  //Sinclair Joystick 2
  if(key&GPC_VK_FA)    ZXKey(SPECKEY_0);
  if(key&GPC_VK_UP)    ZXKey(SPECKEY_9);
  if(key&GPC_VK_DOWN)  ZXKey(SPECKEY_8);
  if(key&GPC_VK_RIGHT) ZXKey(SPECKEY_7);
  if(key&GPC_VK_LEFT)  ZXKey(SPECKEY_6);
 }

}
#else

#include "splash.h"

void SetPalette(unsigned char *p);


void set_zx_palette(int gray)
 {
  int i;

  for(i=0;i<252;i++)
   {
    unsigned char r,g,b;
    r=g=b=0;
    if(i<17)
    {
     r=zx_colours[i][0];
     g=zx_colours[i][1];
     b=zx_colours[i][2];

     if(gray)
     {
      int x=(r+g+b)/3;

      if(x)
      { x+=64-(x/(256/64)); if(x>255) x=255; } //add some bright to dark colors (0<bright<64)
      else
        x=4; //8;                                  //our black is a little bright 

      r=g=b=x;
     }
    }
    SetColor(i,r,g,b);
   }
 }


void init_video(int pal_gui)
{
        GpGraphicModeSet(GPC_DFLAG_8BPP, NULL);
        GpLcdEnable();

        gpDrawSurfaceIndex = 0;

        FlipScreen(1,0);

        GP32_Video=8;

        if(pal_gui) SetPalette(splash_palette);

        SetColor(OTHER_COLOR,200,115,0);
        SetColor(WHITE_COLOR,255,255,255);
        SetColor(BLACK_COLOR,0,0,0);

        {int i; for(i=0;i<320*240;i++) Picture[i]=PictureAlt[i]=BLACK_COLOR; }
}


void display_splash(void)
{
 int x,y,t;

 for(t=0;t<3;t++,FlipScreen(1,0))
 for(x=0;x<320;x++)
  for(y=0;y<240;y++)
   Picture[239-y+x*240]=splash[x+y*320];
}


menu menuZX,menusave,menuvideo,menudebug;
char mReset=0,mBasic=0,mGamma=(200-(int)(GAMMA*100))/2;
char mDebug=0;
char mLoadState=0,mSaveState=0,mLoadMovie=0,mSaveMovie=0,mSnapShot=0;
char mStretch=0,mVSync=0,mBuffering=0,mJoystick=0,mModel=0,mQuick=1;
char mPalette=0;
char emu_running=1;

extern float Gamma;
extern unsigned char gfx_pal_backup[768];
void SetPalette(unsigned char *p);

int save_state(int st)
{
//#define SIZEOFZ80REGS 55
#define SIZEOFZ80REGS sizeof(Z80Regs)
    F_HANDLE fp; unsigned char *mem;
    int count;

    MyStateName[gm_lstrlen(MyStateName)-1]=st+'0';

    if(GpFileCreate(MyStateName,ALWAYS_CREATE,&fp)!=SM_OK) return 0;
    GpFileClose(fp);

    if(GpFileOpen(MyStateName, OPEN_W, &fp)!=SM_OK) return 0;

    mem=(unsigned char*)gm_zi_malloc(16384*16+SIZEOFZ80REGS+100);
    if(mem==NULL) { GpFileClose(fp); while(1); }

    count=ZX_SaveState(&mem[0]);

    GpFileWrite(fp, (void *)&mem[0], count);
    GpFileClose(fp);

    gm_free(mem);

    return 1;
}

int load_state(int st)
{
    F_HANDLE fp; unsigned char *mem;
    uLong temp, size;

//    gm_memset(&mem[0],0,16384*16+SIZEOFZ80REGS+100);

    MyStateName[gm_lstrlen(MyStateName)-1]=st+'0';

    if(GpFileOpen(MyStateName, OPEN_R, &fp)!=SM_OK) return 0;
    GpFileClose(fp);

    GpFileGetSize(MyStateName, &size);

    if(GpFileOpen(MyStateName, OPEN_R, &fp)!=SM_OK) return 0;

    mem=(unsigned char*)gm_zi_malloc(16384*16+SIZEOFZ80REGS+100);
    if(mem==NULL) { GpFileClose(fp); while(1); }

    GpFileRead(fp, (void *)&mem[0], size, &temp);
    GpFileClose(fp);

    {
    int code = ZX_LoadState(&mem[0]);

    gm_free(mem);

    return (code?1:0);
    }
}

void menu_manage(void)
{
     unsigned char *buf, *bufp;
     byte mQuick_old=mQuick;
 
     Gp32_AudioStop();

     buf=bufp=gm_malloc(320*240);

     if(buf==NULL) while(1) { DrawMessageC("not mem enough"); FlipScreen(1,0); DrawMessageC("not mem enough"); FlipScreen(1,0); DrawMessageC("not mem enough"); FlipScreen(1,0); }

     {
       unsigned char *x1=(unsigned char *)LCD_OFFSET0;
       unsigned char *x2=(unsigned char *)LCD_OFFSET1;
       unsigned char *x3=(unsigned char *)LCD_OFFSET2;
       int i;
       for(i=0;i<320*240;i++) (*bufp++)=(*x1++)=*x2++=*x3++;
     }

     while(MenuDisplay(&menuZX,1,1)!=GPC_VK_FB)
     {
      Gamma=(2.00f-(mGamma/50.0f))+0.01f;
      SetPalette(gfx_pal_backup);

      WaitSync();

                  if((int)menudisplayed==(int)&menusave)
                  {
                  if(menusave.selectedline==4)
                  {
                   MenuDisplay(&menuZX,1,0); //update cursor
                   MenuDisplay(&menuZX,1,0); //update cursor
                   MenuDisplay(&menuZX,1,0); //update cursor
                   MenuDisplay(&menuZX,1,0); //update cursor

                     {
                       unsigned char *x1=(unsigned char *)LCD_OFFSET0;
                       unsigned char *x2=(unsigned char *)LCD_OFFSET1;
                       unsigned char *x3=(unsigned char *)LCD_OFFSET2;
                       int i;
                       for(i=0;i<320*240;i++) (*x1++)=*x2++=*x3++;
                     }

                  if(mLoadState)
                  if(load_state(mLoadState-1))
                  {

                  {
                   unsigned char *mini_screen=(unsigned char *)gm_zi_malloc(320*240);

                   if(mini_screen!=NULL)
                   while(GpKeyGet() != GPC_VK_LEFT  &&
                         GpKeyGet() != GPC_VK_RIGHT &&
                         GpKeyGet() != GPC_VK_FA &&
                         GpKeyGet() != GPC_VK_FB )
                   {
                    int x,y; unsigned char *PictureBackup=Picture;

                    Picture=mini_screen;

                    ZX_Frame(0);
                
                    Picture=PictureBackup;

                    for(y=0;y<240;y++)
                     for(x=0;x<320;x++)
                      Picture[239-(y/2+60+37)+(x/2+80)*240]=mini_screen[239-y+x*240];

                    FlipScreen(0,0);
                   }

                   if(mini_screen!=NULL)
                    gm_free(mini_screen);
                  }
                  }
                  }
                  }
     }

     if(mSnapShot)
     {
      static int cSnapShot=0;
      unsigned char *dst=NULL; long size;
      F_HANDLE fp;

      mSnapShot=0;

      if(buf!=NULL) dst=gm_zi_malloc(320*240+2048);

      if(dst!=NULL)
      {
       size=SavePNG8(buf,dst,gfx_pal_backup);

       gm_sprintf(g_string,"Saving snapshot %04d\nPlease wait...",cSnapShot);

       DrawMessageC(g_string); FlipScreen(1,0);
       DrawMessageC(g_string); FlipScreen(1,0);
       DrawMessageC(g_string); FlipScreen(1,0);

       gm_sprintf(g_string,"gp:\\GPMM\\ZX\\SNAPS\\SNAP%04d.PNG",cSnapShot);

       if(GpFileCreate(g_string,ALWAYS_CREATE,&fp)==SM_OK)
       {
        GpFileClose(fp);

        if(GpFileOpen(g_string,OPEN_W,&fp)==SM_OK)
        {
         GpFileWrite(fp,(void *)&dst[0],size);
         GpFileClose(fp);
      
         cSnapShot++;
        }
       }

      gm_free(dst);
      }
     }

     if(mSaveState&&(!mLoadState))
     {
      DrawMessageC("Saving State..."); FlipScreen(1,0);
      DrawMessageC("Saving State..."); FlipScreen(1,0);
      DrawMessageC("Saving State..."); FlipScreen(1,0);

      save_state(mSaveState-1);

      mSaveState=0;
     }

     if(mLoadState&&(!mSaveState))
     {
      DrawMessageC("Loading State..."); FlipScreen(1,0);
      DrawMessageC("Loading State..."); FlipScreen(1,0);
      DrawMessageC("Loading State..."); FlipScreen(1,0);

      load_state(mLoadState-1);

      mLoadState=0;
     }

     if(mLoadState&&mSaveState)
     {
      DrawMessageC("Copying State..."); FlipScreen(1,0);
      DrawMessageC("Copying State..."); FlipScreen(1,0);
      DrawMessageC("Copying State..."); FlipScreen(1,0);

      load_state(mLoadState-1);
      save_state(mSaveState-1);

      mLoadState=mSaveState=0;
     }

/*
     framelimit_delay=0;
*/
     init_video(0);
     SetPalette(gfx_pal_backup);
     set_zx_palette(mPalette);

     if(mModel==1) { mModel=0; ZX_LoadGame(ZX_16,       MyGameCRC, mQuick); }
     if(mModel==2) { mModel=0; ZX_LoadGame(ZX_48,       MyGameCRC, mQuick); }
     if(mModel==3) { mModel=0; ZX_LoadGame(ZX_128,      MyGameCRC, mQuick); }
     if(mModel==4) { mModel=0; ZX_LoadGame(ZX_128_USR0, MyGameCRC, mQuick); }
     if(mModel==5) { mModel=0; ZX_LoadGame(ZX_PLUS2,    MyGameCRC, mQuick); }
     if(mModel==6) { mModel=0; ZX_LoadGame(ZX_PLUS2A,   MyGameCRC, mQuick); }
     if(mModel==7) { mModel=0; ZX_LoadGame(ZX_PLUS3,    MyGameCRC, mQuick); }

     if(mQuick_old!=mQuick) {  ZX_LoadGame(-1, MyGameCRC, mQuick);  }

     if(mReset==1) { mReset=0; ZX_LoadGame(-1, MyGameCRC, mQuick);  }
     if(mReset==2) { mReset=0; emu_running=0; }

     switch(mBasic)
     {
      case 1: mBasic=0; ZX_Reset(ZX_16); break;
      case 2: mBasic=0; ZX_Reset(ZX_48); break;
      case 3: mBasic=0; ZX_Reset(ZX_128); break;
      case 4: mBasic=0; ZX_Reset(ZX_PLUS2); break;
      case 5: mBasic=0; ZX_Reset(ZX_PLUS2A); break;
      case 6: mBasic=0; ZX_Reset(ZX_PLUS3); break;
     }

     gm_free(buf);

     Gp32_AudioStart(0);
}










extern int WindowXAdj,WindowYAdj;

#define KEYBOARD_DELAY 30
#define KEYBOARD_REPEAT 7


 int MenuKeyboard=0;

int VirtualKeyboard(int show)
{
 #define KEYBOARD_ROWS 4

 static char keyboardv[]=    " 1 2 3 4 5 6 7 8 9 0 c=3 \n" \
                             " Q W E R T Y U I O P Shf \n" \
                             " A S D F G H J K L Enter \n" \
                             " Z X C V B N M Sym Space ";

 int keys_per_row[KEYBOARD_ROWS]={11-1,11-1,10-1,9-1};

 int row[KEYBOARD_ROWS][11+2]={
  {0,2,4,6,8,10,12,14,16,18,20,24,-1},
  #define L 24+2
  {L+0,L+2,L+4,L+6,L+8,L+10,L+12,L+14,L+16,L+18,L+20,L+24,-1},  
  #undef L
  #define L 24+2+24+2
  {L+0,L+2,L+4,L+6,L+8,L+10,L+12,L+14,L+16,L+18,L+24,-1},  
  #undef L
  #define L 24+2+24+2+24+2
  {L+0,L+2,L+4,L+6,L+8,L+10,L+12,L+14,L+18,L+24,-1},  
  #undef L
  };

  unsigned int key[KEYBOARD_ROWS][11]={
   {SPECKEY_1,SPECKEY_2,SPECKEY_3,SPECKEY_4,SPECKEY_5,SPECKEY_6,SPECKEY_7,SPECKEY_8,SPECKEY_9,SPECKEY_0,SPECKEY_CTRL},
   {SPECKEY_Q,SPECKEY_W,SPECKEY_E,SPECKEY_R,SPECKEY_T,SPECKEY_Y,SPECKEY_U,SPECKEY_I,SPECKEY_O,SPECKEY_P,SPECKEY_SHIFT},
   {SPECKEY_A,SPECKEY_S,SPECKEY_D,SPECKEY_F,SPECKEY_G,SPECKEY_H,SPECKEY_J,SPECKEY_K,SPECKEY_L,SPECKEY_ENTER},
   {SPECKEY_Z,SPECKEY_X,SPECKEY_C,SPECKEY_V,SPECKEY_B,SPECKEY_N,SPECKEY_M,SPECKEY_SYMB,SPECKEY_SPACE} };


/*
 int keys_per_row[KEYBOARD_ROWS]={10-1,10-1,10-1,10-1};

 int row[KEYBOARD_ROWS][18+2]={
  {0,2,4,6,8,10,12,14,16,18,20,-1},
  #define L 20+2
  {L+0,L+2,L+4,L+6,L+8,L+10,L+12,L+14,L+16,L+18,L+20,-1},  
  #undef L
  #define L 20+2+20+2
  {L+0,L+2,L+4,L+6,L+8,L+10,L+12,L+14,L+16,L+18,L+24,-1},  
  #undef L
  #define L 24+2+20+2+20+2
  {L+0,L+6,L+8,L+10,L+12,L+14,L+16,L+18,L+20,L+24,L+30,-1}  
  #undef L
  };

  unsigned int key[KEYBOARD_ROWS][10]={
   {SPECKEY_1,SPECKEY_2,SPECKEY_3,SPECKEY_4,SPECKEY_5,SPECKEY_6,SPECKEY_7,SPECKEY_8,SPECKEY_9,SPECKEY_0},
   {SPECKEY_Q,SPECKEY_W,SPECKEY_E,SPECKEY_R,SPECKEY_T,SPECKEY_Y,SPECKEY_U,SPECKEY_I,SPECKEY_O,SPECKEY_P},
   {SPECKEY_A,SPECKEY_S,SPECKEY_D,SPECKEY_F,SPECKEY_G,SPECKEY_H,SPECKEY_J,SPECKEY_K,SPECKEY_L,SPECKEY_ENTER},
   {SPECKEY_SHIFT,SPECKEY_Z,SPECKEY_X,SPECKEY_C,SPECKEY_V,SPECKEY_B,SPECKEY_N,SPECKEY_M,SPECKEY_SYMB,SPECKEY_SPACE} };
*/

 static int pause=0, touch=0; //key touch/repeat
 static int keypos=0, rowpos=0;

// if(c&GPC_VK_START) { MenuKeyboard=0; while(GpKeyGet()); FlipScreen(1,1); FlipScreen(1,1); }

 int i,c=GpKeyGet();


 if(show) { DrawMessageD(keyboardv); return 0; }


 if(!c) pause=touch=0;
              
 {
   for(i=0;keyboardv[i]!='\0';i++) if(keyboardv[i]=='^') keyboardv[i]=' ';
                                                                                             
   if(c&GPC_VK_UP)   { if(pause<=0) { if(rowpos>0)                     { rowpos--; keypos=(((keypos*100)/keys_per_row[rowpos+1])*keys_per_row[rowpos])/100; } ; if(!touch) { pause=KEYBOARD_DELAY; touch=1; } } }
    else
   if(c&GPC_VK_DOWN) { if(pause<=0) { if(rowpos<KEYBOARD_ROWS-1)       { rowpos++; keypos=(((keypos*100)/keys_per_row[rowpos-1])*keys_per_row[rowpos])/100; } ; if(!touch) { pause=KEYBOARD_DELAY; touch=1; } } }
    else
   if(c&GPC_VK_LEFT) { if(pause<=0) { if(keypos>=0)                    { keypos--; if(keypos==-1) keypos=keys_per_row[rowpos];  pause=KEYBOARD_REPEAT; } ; if(!touch) { pause=KEYBOARD_DELAY; touch=1; } } }
    else
   if(c&GPC_VK_RIGHT){ if(pause<=0) { if(keypos<=keys_per_row[rowpos]) { keypos++; if(keypos-1==keys_per_row[rowpos]) keypos=0; pause=KEYBOARD_REPEAT; } ; if(!touch) { pause=KEYBOARD_DELAY; touch=1; } } }

   pause--;

  if(c&GPC_VK_FB)
  {
   ZXKey(SPECKEY_SHIFT);
   ZXKey(key[rowpos][keypos]);
  }
  else
  if(c&GPC_VK_FA) 
  {
   ZXKey(key[rowpos][keypos]);
  }

  keyboardv[row[rowpos][keypos]]='^';
  keyboardv[row[rowpos][keypos+1]]='^';
 }

 if(c&GPC_VK_SELECT) { MenuKeyboard=0; while(GpKeyGet()&GPC_VK_SELECT); FlipScreen(1,BorderColor); FlipScreen(1,BorderColor); }
 if(c&GPC_VK_FR) if(c&GPC_VK_FL) MenuKeyboard=0;

 if(c&GPC_VK_DOWN)
 {
  if(rowpos==KEYBOARD_ROWS-1)
   if(WindowYAdj<98-26)  { WindowYAdj++; return 1; } //adjusted for fcol
 }
 else
 if(c&GPC_VK_UP)
 {
  if(rowpos==0)
   if(WindowYAdj>-90+16) { WindowYAdj--; return 1; } //adjusted for fcol
 }

 return 0;
}






















         char fps_string[64];



/* auto fskip / flimit related */
 int now=0, done=0;
 int frames=0;
 int ticks,i=0;
    int  ftick=0;
    int  fframes=0,ffps=0;



void GpMain(void *arg)
{
 int firsttime=1;

  SetCache();
//  swi_mmu_change((unsigned char *)0x0c7b4000,(unsigned char *)0x0cFFFFF,0x00000ff2);
//        GpClockSpeedChange(132000000, 0x3a011, 3); //spiv
//        GpClockSpeedChange(156000000, 0x2c001, 3);
//        GpClockSpeedChange(165000000, 0x2f001, 3);

//        GpClockSpeedChange(132000000, 0x3a011, 3); //spiv



        init_video(1);

        display_splash();

        {
         int speed=132000000, fclk=2;

          GpClockSpeedChange(speed, 0x24001,fclk);
          if(gp_initChatboard(speed/( 1<<(fclk-1) ))) chatboard=1;
         }

        GpFatInit();

        if(chatboard)
         {
          DrawMessageC("Chatboard found!\nPress SMS key, then SPACE key   "); FlipScreen(1,0);
          DrawMessageC("Chatboard found!\nPress SMS key, then SPACE key   "); FlipScreen(1,0);
          DrawMessageC("Chatboard found!\nPress SMS key, then SPACE key   "); FlipScreen(1,0);

          while(gp_getChatboard()!=32);
         }
//      else DelayA();

        if(firsttime)
        {
        char g_string2[512];
        gm_sprintf(g_string2,"fZX32 v%02d/%02d/%02d by rlyeh, who else...\n\nThis port is under donationware license :D\nSend me your damn money now c==3\n\nPaypal donations : rlyeh@emulnation.info\n\nBased on ASpectrum, FUSE, X128 and Caprice.  ",version_emu/10000,(version_emu/100)%100,version_emu%100);

        DrawMessageC(g_string2); FlipScreen(1,0);
        DrawMessageC(g_string2); FlipScreen(1,0);
        DrawMessageC(g_string2); FlipScreen(1,0);
        DelayA();

        display_splash();

        DrawMessageC("Testing folders..."); FlipScreen(1,0);
        DrawMessageC("Testing folders..."); FlipScreen(1,0);
        DrawMessageC("Testing folders..."); FlipScreen(1,0);

        GpDirCreate("gp:\\gpmm", NOT_IF_EXIST);
        GpDirCreate("gp:\\gpmm\\zx", NOT_IF_EXIST);
        GpDirCreate("gp:\\gpmm\\zx\\snaps",NOT_IF_EXIST);
        GpDirCreate("gp:\\gpmm\\zx\\sav",NOT_IF_EXIST);    //aqui ya hay 30 SMC errors :-?

        gm_sprintf(g_path_curr,"gp:\\gpmm\\zx\\");

        display_splash();
        }





 ZX_Init();

 while(1)
 {
        {
        char temp[255];
        gm_sprintf(temp,"-- fZX32 v%02d/%02d/%02d by rlyeh. First release (x-mas edition) --",version_emu/10000,(version_emu/100)%100,version_emu%100);
        fs(temp,"gp:\\GPMM\\ZX","fzx32.ini",GAME);

        gm_sprintf(MyStateName,"gp:\\gpmm\\zx\\sav\\%08x.stx",MyGameCRC);
       }

 init_video(0);

 GAME_size=MyGameSize;

 ZX_LoadGame(ZX_128, MyGameCRC, mQuick);







  MenuInit(&menuZX);

  MenuAdd(&menuZX,OPTIONS,&mReset,BACK,     "Game\tContinue\tRestart\tChange\n");

  MenuAdd(&menuZX,OPTIONS,&mJoystick, BACK, "Map joystick as \tothers\tsinclair 1\tsinclair 2\tOPQAMSP\n");

  MenuAdd(&menuZX,OPTIONS,&mModel,    BACK, "Load tape in \tauto\t16\t48\t128\t128 usr 0\t+2\t+2a\t+3\n");

  MenuAdd(&menuZX,OPTIONS,&mQuick,    BACK, "Load tape\taccurately\tfastest as possible\n");

  MenuAdd(&menuZX,OPTIONS,&mPalette,  BACK, "Monitor type\tcolour\tblack and white\n");

  MenuAdd(&menuZX,OPTIONS,&mBasic,    BACK, "Reboot to BASIC\tno\t16\t48\t128\t+2\t+2A\t+3\n");

  MenuAdd(&menuZX,SUBMENU ,(char *)&menusave,CONTINUE  ,"Load/Save submenu");
  MenuAdd(&menuZX,SUBMENU ,(char *)&menuvideo,CONTINUE ,"Video submenu");
  MenuAdd(&menuZX,SUBMENU ,(char *)&menudebug,CONTINUE ,"Debug submenu");


  MenuInit(&menusave);
  MenuAdd(&menusave,SUBMENUEXIT,(char *)&menuZX,BACK,"Back to previous menu\tBack to previous menu\n");

  MenuAdd(&menusave,BOOLEAN ,&mSnapShot,BACK,"Save Screenshot\tSave Screenshot\n");

  MenuAdd(&menusave,OPTIONS,&mLoadState,BACK,"Load State\tno\t0\t1\t2\t3\t4\t5\t6\t7\t8\t9");
  MenuAdd(&menusave,OPTIONS,&mSaveState,BACK,"Save State\tno\t0\t1\t2\t3\t4\t5\t6\t7\t8\t9\n\n\n\n\n\n");

//  MenuAdd(&menusave,OPTIONS,&mLoadMovie,BACK,"Load Movie (*)\tno\t0\t1\t2\t3\t4\t5\t6\t7\t8\t9");
//  MenuAdd(&menusave,OPTIONS,&mSaveMovie,BACK,"Save Movie (*)\tno\t0\t1\t2\t3\t4\t5\t6\t7\t8\t9");


  MenuInit(&menuvideo);
  MenuAdd(&menuvideo,SUBMENUEXIT,(char *)&menuZX,BACK,"Back to previous menu\tBack to previous menu\n");
  MenuAdd(&menuvideo,PROGRESS,&mGamma,BACK,"Gamma Correction\tMIN\tMAX\t1\t100");

  MenuInit(&menudebug);
  MenuAdd(&menudebug,SUBMENUEXIT,(char *)&menuZX,BACK,"Back to previous menu\tBack to previous menu\n");
  MenuAdd(&menudebug,OPTIONS,&mDebug,BACK,"Debug\toff\ton");










 gm_memset(Picture,BLACK_COLOR,320*240);

 set_zx_palette(mPalette);


  #ifndef SND_ROB
  sndbuf.freq=PCM_M22;  
  sndbuf.format=PCM_8BIT; 
  sndbuf.samples=22050/50; 
  sndbuf.userdata=NULL;
  sndbuf.callback=sound_frame_8;
  sndbuf.pollfreq=5000/60;
  #else

  snd_enabled = 1;

  #endif

  Gp32_AudioStart(0);


 chatboardSymb=chatboardShift=chatboardExt=0;

 emu_running=1;

 mapped_joystick=0;

 /*
 switch(MyGameCRC)
 {
  case 0x54174651: //La Abadia del Crimen
  case 0xd4417b6e:
  case 0x1f2c5975:
  case 0xeb0b35e9:
  case 0x8e1487ce:
  case 0xfcc0a4eb:
  case 0x8482bdc2:
  case 0xa27e43bc:
  case 0xf282f396:
  case 0x057b4250:
                   mapped_joystick=2; 

  default:         mapped_joystick=0;
 }
 */

 while(emu_running)
 {

    {
     if(GpTickCountGet()-ftick>ONE_SECOND)
     {
      int fpercent;
   
      ffps=fframes;
      fframes=0;
      ftick=GpTickCountGet();
      fpercent=((ffps*100)/50)+1; //avoid 0

      gm_sprintf(fps_string,"\n  ^%03d fps,%03d%% speed,%d fskip^",ffps,fpercent,frames);
     }
     else fframes+=0+1; //0fskip means 1frame, 1fskip means 2frames, ...
    }


    #if 1
    ZX_Frame(0);
    GetPad();
    if(mDebug) textOut(fps_string,0,0,WHITE_COLOR,0);
    FlipScreen(0,0);
    #endif

    #if 0

                                        {
                                        now=GpTickCountGet();
                                        ticks=((now-done)*50)/(ONE_SECOND);
					if(ticks<1) continue;
					if(ticks>10) ticks=10; // Limit frame-skipping
//                                      FrameSkip=ticks-1;
					for (i=0; i<ticks-1; i++)
					{
                                                ZX_Frame(1);
						GetPad();
						frames++;
					}

					if(ticks>=1)
					{
                                                ZX_Frame(0);
						GetPad();
						frames++;

                                                if(mDebug) textOut(fps_string,0,0,WHITE_COLOR,0);

                                                FlipScreen(0,0);
                                                //Picture=(unsigned char *)0x0c7b4000;
					}

					done=now;
                                        }

    #endif
 }

 Gp32_AudioStop();

 init_video(1);

 display_splash();
//DelayA();
 }
}


#endif












void GetPad(void)
{
  int key=GpKeyGet();

  if(MenuKeyboard) { VirtualKeyboard(0); VirtualKeyboard(1); return ; }

  if(key&GPC_VK_SELECT) { MenuKeyboard=1; while(GpKeyGet()&GPC_VK_SELECT);  }

  {


  if(0) //key&GPC_VK_START)
  {
   //buscar tb "ENTER/FIRE TO PLAY"


   //ZX_GuessControls();
   //hacer algoritmo busqueda por este orden en *RAM
   //?<>start                                ? : n o letra isalpha <> : varios espacios
   //?<>play
   //?<>empezar
   //?<>jugar
   //?<>1 player
   //?<>one player
   //?<>player 1
   //?<>player one
   //?<>1 jugador
   //?<>un jugador
   //?<>jugador 1
   //?<>jugador uno
  
   //?<>kempston
   //?<>cursor,protek,agf
   //?<>fuller
   //?<>interface, sinclair
   //?<>keyboard
   //?<>teclado
   //al pulsar START, pulsar primero la fila mas alta del segundo grupo, luego la mas alta del primer grupo

   const char *group1[]={ "jugador uno",
   "jugador 1",
   "un jugador",
   "1 jugador",
   "player one",
   "player 1",
   "one player",
   "1 player",
   "jugar",
   "empezar",
   "play",
   "start", NULL};

   const char *group2[] = { "teclado",
   "keyboard",
   "sinclair",
   "interface",
   "fuller",
   "protek",
   "cursor",
   "kempston",
    NULL };


   int g1s=0, g2s=0, found1=-1, found2=-1; //group 1 & 2 searchs

   char RAM[64*1024];

   {
    int x;

    for(x=0;x<64*1024;x++)
    {
     RAM[x]=Z80ReadMem(x);

     if(RAM[x]>='A'&&RAM[x]<='Z') RAM[x]=RAM[x]-'A'+'a';
    }
   }

   while(group1[g1s]!=NULL)
   {
    int x;
    for(x=0;x<64*1024-strlen(group1[g1s])-2;x++)
     if(memcmp(&RAM[x],group1[g1s],strlen(group1[g1s])-2)==0) //LOOK FOR "KEYBOAR", "KEMPSTO", "CURSO" ... BECAUSE SOME GAMES ALTER THE LAST CHAR
     {
      int y;

      for(y=0;y<2;y++)
      {
       if(RAM[x-1-y]>='0'&&RAM[x-1-y]<='9')
        { found1=RAM[x-1-y]-'0'+SPECKEY_0; break; }

       if(RAM[x-1-y]>='a'&&RAM[x-1-y]<='z')
        { found1=RAM[x-1-y]-'a'+SPECKEY_A; break; }
      }
     }
    g1s++;
   }


   while(group2[g2s]!=NULL)
   {
    int x;
    for(x=0;x<64*1024-strlen(group2[g2s])-2;x++)
     if(memcmp(&RAM[x],group2[g2s],strlen(group2[g2s])-2)==0) //LOOK FOR "KEYBOAR", "KEMPSTO", "CURSO" ... BECAUSE SOME GAMES ALTER THE LAST CHAR
     {
      int y;

      for(y=0;y<2;y++)
      {
       if(RAM[x-1-y]>='0'&&RAM[x-1-y]<='9')
        { found2=RAM[x-1-y]-'0'+SPECKEY_0; break; }

       if(RAM[x-1-y]>='a'&&RAM[x-1-y]<='z')
        { found2=RAM[x-1-y]-'a'+SPECKEY_A; break; }
      }
     }
    g2s++;
   }


   /*
   {
    char x[255];
    gm_sprintf(x,"keys found: 2) %c 1) %c",found2<=9?found2-SPECKEY_0+'0':found2-SPECKEY_A+'A',found1<=9?found1-SPECKEY_0+'0':found1-SPECKEY_A+'A');
    DrawMessageC(x); FlipScreen(1,0);
    DrawMessageC(x); FlipScreen(1,0);
    while(GpKeyGet()!=GPC_VK_SELECT);
   }
   */


   if(found1+found2>0)
    {
     int x;
     for(x=0;x<25;x++) { ZX_Frame(1); }
     for(x=0;x<25;x++) { ZX_Frame(1); ZXKey(found2); }
     for(x=0;x<25;x++) { ZX_Frame(1); }
     for(x=0;x<25;x++) { ZX_Frame(1); ZXKey(found1); }
    }
  }



  switch(mJoystick)
  {
   case 0://kempston/i2l+cursor/protek/agf+fuller
          if(key&GPC_VK_FA)    { kempston|=16; ZXKey(SPECKEY_0);     fuller&=0xFF-128;   }
          if(key&GPC_VK_FB)    { kempston|=16; ZXKey(SPECKEY_SPACE); fuller&=0xFF-128;   }
          if(key&GPC_VK_UP)    { kempston|=8;  ZXKey(SPECKEY_7);     fuller&=0xFF-1;     }
          if(key&GPC_VK_DOWN)  { kempston|=4;  ZXKey(SPECKEY_6);     fuller&=0xFF-2;     }
          if(key&GPC_VK_RIGHT) { kempston|=1;  ZXKey(SPECKEY_8);     fuller&=0xFF-8;     }
          if(key&GPC_VK_LEFT)  { kempston|=2;  ZXKey(SPECKEY_5);     fuller&=0xFF-4;     }
          break;

   case 1:
          //Sinclair Joystick 1,Interface II (port 1)
          if(key&GPC_VK_FA)    ZXKey(SPECKEY_0);
          if(key&GPC_VK_FB)    ZXKey(SPECKEY_SPACE); 
          if(key&GPC_VK_UP)    ZXKey(SPECKEY_9);
          if(key&GPC_VK_DOWN)  ZXKey(SPECKEY_8);
          if(key&GPC_VK_RIGHT) ZXKey(SPECKEY_7);
          if(key&GPC_VK_LEFT)  ZXKey(SPECKEY_6);
          break;

   case 2:
          //Sinclair Joystick 2,Interface II (port 2)
          if(key&GPC_VK_FA)    ZXKey(SPECKEY_5);
          if(key&GPC_VK_FB)    ZXKey(SPECKEY_SPACE); 
          if(key&GPC_VK_UP)    ZXKey(SPECKEY_4);
          if(key&GPC_VK_DOWN)  ZXKey(SPECKEY_3);
          if(key&GPC_VK_RIGHT) ZXKey(SPECKEY_2);
          if(key&GPC_VK_LEFT)  ZXKey(SPECKEY_1);
          break;

   case 3://OPAQMSP, or others
          if(key&GPC_VK_LEFT)  ZXKey(mapped_joysticks[mapped_joystick][0]);
          if(key&GPC_VK_RIGHT) ZXKey(mapped_joysticks[mapped_joystick][1]);
          if(key&GPC_VK_UP)    ZXKey(mapped_joysticks[mapped_joystick][2]);
          if(key&GPC_VK_DOWN)  ZXKey(mapped_joysticks[mapped_joystick][3]);
          if(key&GPC_VK_FA)    ZXKey(mapped_joysticks[mapped_joystick][4]);
          if(key&GPC_VK_FB)    ZXKey(mapped_joysticks[mapped_joystick][5]); 
          break;
   }



   if(chatboard)
   {
    int keypressed=1;

    if(!chatboardExt)
    {
        if(!(chatboardSymb && chatboardShift)) //if not in spectrum E mode...
            {
             if(chatboardShift) ZXKey(SPECKEY_SHIFT);
        
             if(chatboardSymb)  ZXKey(SPECKEY_SYMB);
            }
    }
    else
    {
        ZXKey(SPECKEY_SHIFT);
    }
    
    switch(gp_getChatboard())
    {
     case '<':  ZXKey(SPECKEY_SHIFT);

                keypressed=0;

                if(chatboardSymb && chatboardShift) chatboardExt^=1; else chatboardShift^=1;

                break;

     case '>':  ZXKey(SPECKEY_SYMB);

                keypressed=0;

                if(chatboardSymb && chatboardShift) chatboardExt^=1; else chatboardSymb^=1;

                break;

     case '0':  ZXKey(SPECKEY_0); break;
     case '1':  ZXKey(SPECKEY_1); break;
     case '2':  ZXKey(SPECKEY_2); break;
     case '3':  ZXKey(SPECKEY_3); break;
     case '4':  ZXKey(SPECKEY_4); break;
     case '5':  ZXKey(SPECKEY_5); break;
     case '6':  ZXKey(SPECKEY_6); break;
     case '7':  ZXKey(SPECKEY_7); break;
     case '8':  ZXKey(SPECKEY_8); break;
     case '9':  ZXKey(SPECKEY_9); break;
     case 'A':  ZXKey(SPECKEY_A); break;
     case 'B':  ZXKey(SPECKEY_B); break;
     case 'C':  ZXKey(SPECKEY_C); break;
     case 'D':  ZXKey(SPECKEY_D); break;
     case 'E':  ZXKey(SPECKEY_E); break;
     case 'F':  ZXKey(SPECKEY_F); break;
     case 'G':  ZXKey(SPECKEY_G); break;
     case 'H':  ZXKey(SPECKEY_H); break;
     case 'I':  ZXKey(SPECKEY_I); break;
     case 'J':  ZXKey(SPECKEY_J); break;
     case 'K':  ZXKey(SPECKEY_K); break;
     case 'L':  ZXKey(SPECKEY_L); break;
     case 'M':  ZXKey(SPECKEY_M); break;
     case 'N':  ZXKey(SPECKEY_N); break;
     case 'O':  ZXKey(SPECKEY_O); break;
     case 'P':  ZXKey(SPECKEY_P); break;
     case 'Q':  ZXKey(SPECKEY_Q); break;
     case 'R':  ZXKey(SPECKEY_R); break;
     case 'S':  ZXKey(SPECKEY_S); break;
     case 'T':  ZXKey(SPECKEY_T); break;
     case 'U':  ZXKey(SPECKEY_U); break;
     case 'V':  ZXKey(SPECKEY_V); break;
     case 'W':  ZXKey(SPECKEY_W); break;
     case 'X':  ZXKey(SPECKEY_X); break;
     case 'Y':  ZXKey(SPECKEY_Y); break;
     case 'Z':  ZXKey(SPECKEY_Z); break;
     case ' ':  ZXKey(SPECKEY_SPACE); break;
     case '.':  ZXKey(SPECKEY_ENTER); break;
     case '\r': ZXKey(SPECKEY_SHIFT); ZXKey(SPECKEY_0); chatboardSymb=0; break;

     default: keypressed=0;
    }

    if(keypressed) if(chatboardSymb && chatboardShift) chatboardSymb=chatboardShift=chatboardExt=0;

   }

   if((key&(GPC_VK_FL|GPC_VK_FR))==(GPC_VK_FL|GPC_VK_FR)) menu_manage();

   }
}
